Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJLST1.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGJLST1.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJLST1.m	(revision 636)
@@ -1,4 +1,4 @@
 MAGJLST1 ;WIRMFO/JHC VistARad RPC calls ; 29 Jul 2003  10:01 AM
- ;;3.0;IMAGING;**16,22,18,65,76**;Jun 22, 2007;Build 19
+ ;;3.0;IMAGING;**16,22,18,65**;Jul 27, 2006;Build 28
  ;;Per VHA Directive 2004-038, this routine should not be modified.
  ;; +---------------------------------------------------------------+
@@ -43,10 +43,9 @@
  ; 
  ; MAGGRY - indirect reference to return array of exams for a patient
- ; DATA   - DFN ^ LIMYEARS ^ LIMEXAMS ^ BEGDT ^ ONESHOT
+ ; DATA   - DFN ^ LIMYEARS ^ LIMEXAMS ^ BEGDT
  ;   DFN--Patient's DFN
- ;   LIMYRS--Restrict exams up to # Years back (defunct)
+ ;   LIMYRS--Restrict exams up to # Years back
  ;   LIMEXAMS--Restrict exams up to # of exams
  ;   BEGDT--Begin date for exam fetch (Patch 18 addition--see below)
- ;   ONESHOT--Number days back to search, in one fell swoop
  ; Returns data in ^TMP($J,"MAGRAEX",0:n)
  ; RPC Call: MAGJ PTRADEXAMS
@@ -64,6 +63,6 @@
  N CNT,DFN,ISS,PATNAME,DIQUIET,MAGRACNT,MAGRET,REPLY,REMOTE,SNDREMOT
  N DAYCASE,DIV,EXCAT,MAGDT,XX,XX2,WHOLOCK,MODALITY,MYLOCK,PLACE,ENDLOOP
- N LIMEXAMS,BEGDT,SAVBEGDT,ENDDT,MORE,SHOWPLAC,RDRIST,PSSN,CPT,PARAM
- N CURPRIO,STATUS,RARPT,KEY,X2,REMOTE2,ONESHOT,LIMDAYS
+ N LIMYRS,LIMEXAMS,BEGDT,SAVBEGDT,ENDDT,MORE,SHOWPLAC,RDRIST,PSSN,CPT,PARAM
+ N CURPRIO,STATUS,RARPT,KEY,X1,X2,REMOTE2,ONESHOT,LIMDAYS
  N IMGCNT,LRFLAG,MSG,ONL,PROCMOD,RASTCAT,RASTORD
  N $ETRAP,$ESTACK S $ETRAP="D ERR^MAGJLST1"
@@ -79,4 +78,7 @@
  E  S BEGDT=$P(DATA,U,4),ONESHOT=$P(DATA,U,5)  ; P65 chg
  K MAGGRY S DFN=+DATA
+ ;<*>
+ ; I DUZ=131 G MANYTST^ZMAGJTST ; <*> TEST ONLY !!!  37=RadRes
+ ;<*>
  S SHOWPLAC=$$SHOWPLAC^MAGJLS2B("")
  S MAGRACNT=1,CNT=0 K ^TMP($J,"MAGRAEX"),^("MAGRAEX2")
@@ -84,12 +86,10 @@
  I DFN,$D(^DPT(DFN,0)) S PATNAME=$P(^(0),U),PSSN=$P(^(0),U,9) D
  . S ENDLOOP=0,BEGDT=$S(+BEGDT:BEGDT,1:"")
- . I MAGJOB("P32"),+$G(MAGJOB("P32STOP")) S REPLY="0^4~VistARad Patch 32 is no longer supported; contact Imaging Support for the current version of the VistARad client software." Q  ; <*>
- . F  D  Q:'MORE  Q:ENDLOOP  S BEGDT=MORE+1
+ . F  D  Q:'MORE  Q:ENDLOOP
  . . I 'BEGDT S BEGDT=DT,X2=0
  . . E  S X2=-1
- . . S LIMDAYS=365,MORE=1
- . . I 'MAGJOB("P32") I ONESHOT,(ONESHOT>0) S LIMDAYS=+ONESHOT
- . . S ENDDT=$$FMADD^XLFDT(BEGDT,X2)
- . . S BEGDT=$$FMADD^XLFDT(ENDDT,-LIMDAYS)
+ . . S LIMDAYS=365
+ . . I 'MAGJOB("P32"),ONESHOT,(ONESHOT>0) S LIMDAYS=+ONESHOT
+ . . S X1=BEGDT D C^%DTC S (ENDDT,X1)=X,X2=-LIMDAYS D C^%DTC S BEGDT=X K %,%H,%T
  . . D GETEXAM3^MAGJUTL1(DFN,BEGDT,ENDDT,.MAGRACNT,.MAGRET,.MORE)
  . . I MAGJOB("P32") S ENDLOOP=(MAGRACNT>LIMEXAMS)
@@ -109,5 +109,4 @@
  . E  S REPLY=REPLY_" -- "_MSG
  . S ^TMP($J,"MAGRAEX2",1)="^Day/Case~S3~1^Lock~~2^Procedure~~6^Modifier~~25^Image Date/Time~S1~7^Status~~8^# Img~S2~9^Onl~~10"_$S($G(SNDREMOT):"^RC~~12",1:"")_$S(SHOWPLAC:"^Site~~23",1:"")_"^Mod~~15^Interp By~~20^Imaging Loc~~11^CPT~~27"
- I MAGJOB("P32"),+$G(MAGJOB("P32STOP")) S ^TMP($J,"MAGRAEX2",1)="^^"
  I 'MAGJOB("P32") S $P(REPLY,"|",2)=SAVBEGDT
  S ^TMP($J,"MAGRAEX2",0)=REPLY
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJMN1.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGJMN1.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJMN1.m	(revision 636)
@@ -1,4 +1,4 @@
 MAGJMN1 ;WIRMFO/JHC VRad Maint functions ; 29 Jul 2003  4:02 PM
- ;;3.0;IMAGING;**16,9,22,18,65,76**;Jun 22, 2007;Build 19
+ ;;3.0;IMAGING;**16,9,22,18,65**;Jul 27, 2006;Build 28
  ;;Per VHA Directive 2004-038, this routine should not be modified.
  ;; +---------------------------------------------------------------+
@@ -31,5 +31,5 @@
  D ENSRCH
  D BLDDEF(MAGIEN)
- S $P(^MAG(2006.631,MAGIEN,0),U,5)=$$NOW^XLFDT()
+ D NOW^%DTC S $P(^MAG(2006.631,MAGIEN,0),U,5)=%
  W !!,"List Definition complete!" R X:2
  G SVRLIST
@@ -115,5 +115,5 @@
  . S STR=STR_$S(STR="":"",1:U)_X
  S ^MAG(2006.631,LSTID,"DEF",2)=STR
- S $P(^MAG(2006.631,LSTID,"DEF",0),U)=$$NOW^XLFDT()
+ D NOW^%DTC S $P(^MAG(2006.631,LSTID,"DEF",0),U)=%
  Q
  ;
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJUPD1.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGJUPD1.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJUPD1.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGJUPD1 ;WOIFO/JHC VistARad Update Exam Status ; 29 Jul 2003  10:02 AM
- ;;3.0;IMAGING;**16,22,18,76**;Jun 22, 2007;Build 19
- ;;Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**16,22,18**;Mar 07, 2006
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -45,5 +44,5 @@
  K MAGGRY S MAGGRY=$NA(^TMP($J,MAGLST)) K @MAGGRY  ; assign MAGGRY value
  S DIQUIET=1 D DT^DICRW
- S TIMESTMP=$$NOW^XLFDT()
+ D NOW^%DTC S TIMESTMP=%
  S UPDFLAG=$P(PARAMS,U),RADFN=$P(PARAMS,U,2),RADTI=$P(PARAMS,U,3),RACNI=$P(PARAMS,U,4),RARPT=$P(PARAMS,U,5),UPDPSKEY=+$P(PARAMS,U,6)
  S REPLY="0^4~Closing case with"_$S(UPDFLAG:"",1:" NO")_" Status Update"
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJUPD2.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGJUPD2.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJUPD2.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGJUPD2 ;WIRMFO/JHC VistaRad RPCs-Update PS & KEY Img ; 14 July 2004  10:05 AM
- ;;3.0;IMAGING;**18,76**;Jun 22, 2007;Build 19
- ;;Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**18**;Mar 07, 2006
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -33,5 +32,5 @@
  S (IMGCT,PSTOT,PSLINCT,KEYCT,INTCT,PSKILCT)=0
  S IMGREF="",SAVOP="NOOP"
- I '$D(TIMESTMP) N TIMESTMP S TIMESTMP=$$NOW^XLFDT()
+ I '$D(TIMESTMP) N TIMESTMP D NOW^%DTC S TIMESTMP=%
  ; 1st, process input in DATA
  S IDATA=""
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJUTL1.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGJUTL1.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJUTL1.m	(revision 636)
@@ -1,4 +1,4 @@
 MAGJUTL1 ;WIRMFO/JHC VistARad subroutines for RPC calls ; 29 Jul 2003  10:03 AM
- ;;3.0;IMAGING;**22,18,65,76**;Jun 22, 2007;Build 19
+ ;;3.0;IMAGING;**22,18,65**;Jul 27, 2006;Build 28
  ;;Per VHA Directive 2004-038, this routine should not be modified.
  ;; +---------------------------------------------------------------+
@@ -25,6 +25,5 @@
  ;
 GETEXAM3(DFN,BEGDT,ENDT,MAGRACNT,MAGRET,MORE,LIMEXAMS) ; Get data for all exams for a
- ; pt within a date range
- ; limit to LIMEXAMS entries--note, only PREFETCH & Auto-route Priors use this
+ ; pt within a date range (default all dates); limit returned list to LIMEXAMS
  ; Input:
  ;      DFN -- Patient DFN
@@ -32,5 +31,4 @@
  ;     ENDT -- Opt, latest date desired
  ; MAGRACNT -- Opt, pass by ref to init counter to ref return data in ^TMP (see GETEXSET)
- ;    MORE -- Opt, If True, check for additional exams for pt
  ; LIMEXAMS -- Opt, limit # exams to return
  ; Return:
@@ -41,7 +39,8 @@
  ;
  I '$D(DT) N DIQUIET S DIQUIET=1 D DT^DICRW
+ N MORECHK
  S LIMEXAMS=+$G(LIMEXAMS)
+ S MORECHK=BEGDT!LIMEXAMS
  S:$G(BEGDT)="" BEGDT=2010101 S:$G(ENDT)="" ENDT=DT ; default all dates
- N MORECHK S MORECHK=+$G(MORE)
  S MAGRACNT=+$G(MAGRACNT),MAGRET=0,MORE=0  ; Init return data
  I BEGDT>ENDT S X=ENDT,ENDT=BEGDT,BEGDT=X
@@ -54,13 +53,10 @@
  K ^TMP($J,"RAE1")
  I 'MORECHK Q  ; all done; else indicate if pt has more exams
- N DTI,CNI,STS,DTCHK
+ N DTI,CNI,STS
  I 'MAGRET S DTI=9999999.9999-BEGDT,CNI=0 ; no exam found in orig dt range
  E  S X=^TMP($J,"MAGRAEX",MAGRACNT,1),DTI=$P(X,U,2),CNI=$P(X,U,3) ; last exam processed
  ; loop thru addl exams til find one that is NOT Cancelled
 MORE1 F  S CNI=$O(^RADPT(DFN,"DT",DTI,"P",CNI)) Q:'CNI  S STS=$P($G(^(CNI,0)),U,3) I STS]"" D  Q:MORE
- . Q:($P($G(^RA(72,STS,0)),U,3)=0)  ; Canceled--keep looking
- . S DTCHK=9999999.9999-DTI D EN1^RAO7PC1(DFN,DTCHK,DTCHK,1)  ; verify there is at least one "good" exam for this date (Remedy #200480)
- . I +$O(^TMP($J,"RAE1",DFN,0)) S MORE=1
- . K ^TMP($J,"RAE1")
+ . S MORE='($P($G(^RA(72,STS,0)),U,3)=0) ; True if sts is NOT Canc
  I 'MORE S DTI=$O(^RADPT(DFN,"DT",DTI)),CNI=0 G MORE1:DTI
  I MORE S MORE=9999999.9999-DTI\1
@@ -131,5 +127,5 @@
  . S IEN=0
  . F  S IEN=$O(^RADPT(RADFN,"DT",RADTI,"P",RACNI,"CMOD",IEN)) Q:'IEN  S X=$P($G(^(IEN,0)),U) I X D
- . . S X=$P($$MOD^ICPTMOD(X,"I"),U,3) Q:X=""  S X=$$TRIM(X)
+ . . S X=$P($G(^DIC(81.3,X,0)),U,2) Q:X=""  S X=$$TRIM(X)
  . . S X=$S(X="LEFT SIDE":"LEFT",X="RIGHT SIDE":"RIGHT",X="BILATERAL PROCEDURE":"BILAT",1:X)
  . . S CT=CT+1,MODS(CT)=X
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJUTL2.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGJUTL2.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJUTL2.m	(revision 636)
@@ -1,4 +1,4 @@
 MAGJUTL2 ;WIRMFO/JHC VistRad subroutines for RPC calls[ 2/21/97  10:53 AM ] ; 22 Mar 2001  2:24 PM
- ;;3.0;IMAGING;**18,65,76**;Jun 22, 2007;Build 19
+ ;;3.0;IMAGING;**18,65**;Jul 27, 2006;Build 28
  ;;Per VHA Directive 2004-038, this routine should not be modified.
  ;; +---------------------------------------------------------------+
@@ -40,6 +40,5 @@
  . I STIEN S T=$O(^MAG(2005,STIEN,205,0)) I T S KEY=1
  S IRPT=0 F  S IRPT=$O(^RARPT(RARPT,2005,IRPT)) Q:'IRPT  S MAGIEN=$P(^(IRPT,0),U) D
- . Q:'$D(^MAG(2005,MAGIEN,0))
- . I MAGDT="" S MAGDT=$P($G(^MAG(2005,MAGIEN,100)),U,6) S:MAGDT="" MAGDT=$P($G(^(2)),U)
+ . Q:'$D(^MAG(2005,MAGIEN,0))  I MAGDT="" S MAGDT=$P($G(^(2)),U)
  . I $O(^MAG(2005,MAGIEN,1,0)) S CT=CT+$P(^(0),U,4),Y=$P(^(0),U,3),MAGIEN2=$P($G(^(Y,0)),U) S:(MAGIEN2]"") ONLCHK=$$ONLCHK(MAGIEN2),REMCHK=$$REMOTE(MAGIEN2) ; last image in group
  . E  S CT=CT+1,ONLCHK=$$ONLCHK(MAGIEN),REMCHK=$$REMOTE(MAGIEN)
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJUTL3.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGJUTL3.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJUTL3.m	(revision 636)
@@ -1,4 +1,4 @@
 MAGJUTL3 ;WIRMFO/JHC VistARad subrtns & RPCs ; 29 Jul 2003  10:03 AM
- ;;3.0;IMAGING;**16,9,22,18,65,76**;Jun 22, 2007;Build 19
+ ;;3.0;IMAGING;**16,9,22,18,65**;Jul 27, 2006;Build 28
  ;;Per VHA Directive 2004-038, this routine should not be modified.
  ;; +---------------------------------------------------------------+
@@ -137,6 +137,5 @@
  I $G(MAGJOB("VRVERSION")) S X=MAGJOB("VRVERSION")
  E  S X="" ; non-client processes assume post-P32 logic
- S MAGJOB("P32")=(X="3.0.41.17") ; P32 Client?
- I MAGJOB("P32") D P32STOP^MAGJUTL5(.X) S MAGJOB("P32STOP")=X  ; STOP support when P76 releases
+ S MAGJOB("P32")=(X="3.0.41.17") ; support back-compatible P32 Client
  D USERKEYS
  S MAGJOB("CONSOLIDATED")=($G(^MAG(2006.1,"CONSOLIDATED"))="YES")
@@ -171,8 +170,9 @@
  Q RSL
  ;
-USERKEYS ; Store Security Keys in MagJob
+USERKEYS ; Store VRad Security Keys in MagJob
+ ;
  N I,X,Y
- N MAGKS ; keys to send to XUS KEY CHECK
- N MAGKG ; returned
+ N MAGKS ; list of keys to send to XUS KEY CHECK
+ N MAGKG ; list returned
  K MAGJOB("KEYS")
  S X="MAGJ",I=0
@@ -184,4 +184,5 @@
  Q
  ;
+ Q
 PINF1(MAGGRY,MAGDFN) ;RPC Call MAGJ PT INFO -- Get pt info
  S X="ERR3^MAGJUTL3",@^%ZOSF("TRAP")
@@ -189,17 +190,16 @@
  Q
  ;
-USERINF2(MAGGRY,DATA) ; rpc: MAGJ USER2--get user info
- ; Input= unused ^ Client Vs ^ Client O/S Vs
- ; Reply=
- ; 0) = 1/0^code~Msg |  DUZ ^ NAME ^ INITIALS ^ REQFLAG
- ; 1)= Net UserName ^ PSW ^ UserType ^ SYSADMIN
- ;     1/0=Success/Fail flag for vs chk
- ;     code=4 if fail
- ;     Msg=Disp msg if fail
- ;     REQFLAG = 1/0 (Ena/Disa Requisition for non-rad staff)
- ;     UserType = 3: Staff R'ist; 2: Resident R'ist; 1: Rad Tech; 0: Non-Rad
- ;     SYSADMIN = 1/0 1=user has System User privileges
- ; 2:N)=Sec Keys
- ;  
+USERINF2(MAGGRY,DATA) ; rpc: MAGJ USER2 -- Return user info
+ ;  Input = unused ^ Client Vrad Vs ^ Client O/S Vs
+ ;  Reply = 
+ ;  (0) = 1/0^code~Msg |  DUZ ^ NAME ^ INITIALS ^ REQ_FLAG
+ ;  (1)= Net UserName ^ PSW ^ UserType ^ SYSADMIN
+ ;      1/0=Success/Failure flag for vs compatibility
+ ;      code=4 if failure condition
+ ;      Msg=Display msg if failure condition
+ ;      REQ_FLAG = 1/0 (Enable/Disable Requisition for non-rad staff)
+ ;      UserType = 3: Staff R'ist; 2: Resident R'ist; 1: Rad Tech; 0: Non-Rad
+ ;      SYSADMIN = 1/0 1=user has Vrad System User privileges
+ ;
  S X="ERR2^MAGJUTL3",@^%ZOSF("TRAP")
  K MAGGRY S MAGGRY(0)="",MAGGRY(1)=""
@@ -225,6 +225,4 @@
  S X=+MAGJOB("USER",1),X=$S(X=15:3,X=12:2,+RADTECH:1,1:0)
  S MAGGRY(1)=MAGGRY(1)_U_X_U_$D(MAGJOB("KEYS","MAGJ SYSTEM USER"))
- S MAGGRY(2)="*KEYS",X="" F I=3:1 S X=$O(MAGJOB("KEYS",X)) Q:X=""  S MAGGRY(I)=X
- S MAGGRY(I)="*END"
 USERIN2Z Q
  ;
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJUTL4.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGJUTL4.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJUTL4.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGJUTL4 ;WIRMFO/JHC VistARad subroutines for RPC calls ; 15 Jul 2004  4:34 PM
- ;;3.0;IMAGING;**18,76**;Jun 22, 2007;Build 19
- ;;Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**18**;Mar 07, 2006
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -66,5 +65,5 @@
  S IEN=0 F  S IEN=$O(RET(IEN)) Q:'IEN  D
  . N LIN S X=$G(@CPTGLB@(IEN,0))
- . Q:'(X]"")  S TCPT=$P(X,U),LIN=TCPT_U_$P($$CPT^ICPTCOD(TCPT),U,3) ; _U_$$BODPART(IEN,"~")_U_$$MDLLST(IEN,"~")
+ . Q:'(X]"")  S TCPT=$P(X,U),LIN=TCPT_U_$P($G(^ICPT(TCPT,0)),U,2) ; _U_$$BODPART(IEN,"~")_U_$$MDLLST(IEN,"~")
  . S CT=CT+1,@MAGGRY@(CT)=LIN
  S REPLY=CT_U_"1~ "_CT_" CPT Matches returned for "_CPTIN
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJUTL5.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGJUTL5.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJUTL5.m	(revision 636)
@@ -1,4 +1,4 @@
 MAGJUTL5 ;WOIFO/JHC - VistARad RPCs ; [ 07/3/2006 17:17 ]
- ;;3.0;IMAGING;**65,76**;Jun 22, 2007;Build 19
+ ;;3.0;IMAGING;**65**;Jul 27, 2006;Build 28
  ;;Per VHA Directive 2004-038, this routine should not be modified.
  ;; +---------------------------------------------------------------+
@@ -24,7 +24,7 @@
  ; released Client will have the T version that the server expects
  ;
- S SVRVER="3.0.76",SVRTVER=14  ; <*> Edit this line for each patch/T-version
+ S SVRVER="3.0.65",SVRTVER=12  ; <*> Edit this line for each patch/T-version
  ;
- S ALLOWCL="|3.0.65|"  ;
+ S ALLOWCL="|3.0.18|"  ; note--patch 32 is numbered funny, so is hard-coded below
  Q
  ;
@@ -68,8 +68,14 @@
  S SVERSION=SV
  I TESTFLAG S SVERSION=SV_"."_ST
- ; Check Version differences:
+ ;
+ ; Patch 32 client is OK:
+ I CLVER="3.0.41.17" S MAGRY="1^1~P32 Client Version Check OK. Server: "_SVERSION_" Client: "_CLVER Q
+ ; Other Version differences:
  I (CV'=SV) D  Q
  . I '(ALLOWV[("|"_CV_"|")) D  Q
  . . S MAGRY="0^4~VistARad Workstation software version "_CLVER_" is not compatible with the VistA server version "_SVERSION_".  Contact Imaging support. (CNA)"
+ . ; Don't allow Test versions of P18
+ . I CP=18,(CT'=132) D  Q
+ . . S MAGRY="0^4~VistARad Workstation software version "_CLVER_" is not compatible with the VistA server version "_SVERSION_".  Contact Imaging support. (C18T)"
  . ; Warn the Client, allow to continue
  . I TESTFLAG S MAGRY="2^3~VistARad Workstation software version "_CLVER_" is running with VistA server TEST Version "_SVERSION_" --  VistARad will Continue, but contact Imaging Support if problems occur. (Pdif)"
@@ -89,16 +95,4 @@
  Q
  ;
-P32STOP(RET) ; logic to indicate P32 should no longer function, once the RELEASED P76 is installed
- ; This is invoked from magjutl3, P76 version, if a P32 client is launched
- ; RET=1/0 ^ text -- 0 = OK to run P32; 1 = Not OK
- N SV,ST,ALLOWV,SVSTAT,RELEASED
- S RET="0^P32 supported" ; init return to allow p32 to function
- D GETVER(.SV,.ST,.ALLOWV)
- D VERSTAT(.SVSTAT,SV)
- I 'SVSTAT S RET="0^Error, but on side of caution, allow running." Q  ; KIDS status for this version indeterminate
- S RELEASED=(+SVSTAT=2)
- I RELEASED!(SV'="3.0.76") S RET="1^P32 support over"  ; don't allow P32 to function
- Q
- ;
 VERSTAT(MAGRY,MAGVER) ;
  ; Returns the status of an Imaging Version
@@ -109,5 +103,5 @@
  N VERI,TVER,MAGERR
  I +MAGVER S MAGVER="MAG*"_$P(MAGVER,".",1,2)_"*"_$P(MAGVER,".",3)
- S VERI=$$FIND1^DIC(9.6,"","O",MAGVER,"","","MAGERR")
+ S VERI=$$FIND1^DIC(9.6,"","",MAGVER,"","","MAGERR")
  I 'VERI S MAGRY="0^4~There is No KIDs Install record."
  E  D
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGLOG.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGLOG.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGLOG.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGLOG ;WOIFO/RED,SRR,MLH - Log image access ; [ 06/20/2001 08:57 ]
- ;;3.0;IMAGING;**17,8,20,59**;Nov 27, 2007;Build 20
- ;;Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**17,8,20**;Apr 12, 2006
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -39,10 +38,7 @@
  I $D(MAGAD) S ^MAG(2006.95,MAGC,100)=MAGAD
  S ^MAG(2006.95,"B",MAGC,MAGC)=""
- D ACCESS(MAGO) ; This should be here.  Can now search 2006.95 from "Last Access Date" to "Capture Date" to
- ; get all Actions logged. We Don't have to search entire Image File.
  I $G(MAGJOB("SESSION")) S ^MAG(2006.95,"AS",+$G(MAGJOB("SESSION")),MAGC)=""
  Q
 ACCESS(MAGO) ; Update Field "Last Access Date" in Image File.
- Q:'$G(MAGO)
  I '$D(^MAG(2005,MAGO,0)) D  Q
  . I $D(^MAG(2005.1,MAGO,0)) S $P(^MAG(2005.1,MAGO,0),"^",9)=$$NOW^XLFDT
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGQBPG1.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGQBPG1.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGQBPG1.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGQBPG1 ;WOIFO/RMP - REMOTE Task SERVER Program [ 11/08/2001 17:18 ]
- ;;3.0;IMAGING;**7,8,20,81**;May 17, 2007
- ;;  Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**7,8,20**;Apr 12, 2006
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -9,4 +8,5 @@
  ;; | Development Office of the Department of Veterans Affairs,     |
  ;; | telephone (301) 734-0100.                                     |
+ ;; |                                                               |
  ;; | The Food and Drug Administration classifies this software as  |
  ;; | a medical device.  As such, it may not be changed in any way. |
@@ -79,5 +79,5 @@
 CNP2(RESULT,IEN,START,STOP) ;[MAGQ JBSCN]
  S X="ERR^MAGQBTM",@^%ZOSF("TRAP")
- N FNAME,PIECE,ZNODE,NODE2,BNODE,BNAME,PTR,HASH,TEMP,ORDER,RDATE,PLACE,OFFLINE,PLACEOK,GL,END,ACQSITE
+ N FNAME,PIECE,ZNODE,NODE2,BNODE,BNAME,PTR,HASH,TEMP,ORDER,RDATE,PLACE,OFFLINE,PLACEOK,GL,END
  S (RESULT,GL)="",PLACE=$$PLACE^MAGBAPI(+$G(DUZ(2))),(OFFLINE,PLACEOK)=0
  S:START="" START=$O(^MAG(2005,0)) S:STOP="" STOP=$O(^MAG(2005,"A"),-1)
@@ -91,8 +91,8 @@
  . Q
  S IEN=+IEN
- F  D SCAN^MAGQBPG1(.IEN,ORDER,.GL) D  Q:((('OFFLINE)&PLACEOK)!('IEN)!($P(RESULT,U,21)="DUPE")!'$G(ACQSITE))
+ F  D SCAN^MAGQBPG1(.IEN,ORDER,.GL) D  Q:((('OFFLINE)&PLACEOK)!('IEN)!($P(RESULT,U,21)="DUPE"))
  . Q:'IEN
- . S ZNODE=$G(@(GL_IEN_",0)")),ACQSITE=$P($G(@(GL_IEN_",100)")),U,3)
- . S PLACEOK=$S($$PLACE^MAGBAPI(+ACQSITE)=$$PLACE^MAGBAPI($G(DUZ(2))):1,1:"")
+ . S ZNODE=$G(@(GL_IEN_",0)"))
+ . S PLACEOK=$S($P($G(@(GL_IEN_",100)")),U,3)=$G(DUZ(2)):1,1:"")
  . I $P(ZNODE,U,2)'="" S OFFLINE=$$IMOFFLN^MAGFILEB($P(ZNODE,U,2))  ; Only check the offline status of image files
  . I ($D(^MAG(2005.1,IEN,0))&$D(^MAG(2005,IEN,0))) D  Q  ; Image is duplicated in the Archive file
@@ -133,6 +133,4 @@
  . I $D(@(GL_IEN_",""FBIG"")")),'$P(BNODE,U),'$P(BNODE,U,2) S $P(RESULT,U,22)="EMPTY_FBIG"
  . Q
- I '$P($G(@(GL_IEN_",100)")),U,3) S $P(RESULT,U,23)=-1 ;"NO ACQ SITE VALUE"
- ;
  I GL[("^MAG(2005.1,") S $P(RESULT,U,21)="ARCH"
  E  S $P(RESULT,U,12,17)=$$CHKIMG^MAGQBUT2(IEN)
@@ -187,5 +185,4 @@
  . D ^XMD
  . K ^TMP($J,"MAGQDFN")
- . K XMSUB
  . Q
  E  S CNT=CNT+1,^TMP($J,"MAGQDFN",CNT)=INPUT
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGQBPRG.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGQBPRG.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGQBPRG.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGQBPRG ;WOIOFO/RMP Magnetic Server Purge processes [ 06/29/2001 18:28 ]
- ;;3.0;IMAGING;**7,3,8,20,81**;May 17, 2007
- ;;  Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**7,3,8,20**;Apr 12, 2006
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -9,4 +8,5 @@
  ;; | Development Office of the Department of Veterans Affairs,     |
  ;; | telephone (301) 734-0100.                                     |
+ ;; |                                                               |
  ;; | The Food and Drug Administration classifies this software as  |
  ;; | a medical device.  As such, it may not be changed in any way  |
@@ -54,5 +54,5 @@
  ;        17 = Jukebox offline
  N FILEXT,IEN,SITEID,MAGXX,MAGFILE,MAGFILE1,MAGFILE2,PACS,RIEN,ZNODE
- N FILETYPE,CPTR,JBPTR,CPOK,BNODE,ALTPATH,NMSPC,PLACE,RDHOLD,XX
+ N FILETYPE,CPTR,JBPTR,CPOK,BNODE,ALTPATH,NMSPC,PLACE,RDHOLD
  S X="ERR^MAGQBTM",@^%ZOSF("TRAP")
  S PLACE=$$PLACE^MAGBAPI(+$G(DUZ(2)))
@@ -84,5 +84,5 @@
  . E  S RESULT="1^^9^^^"_IEN
  . Q
- I PLACE'=$$PLACE^MAGBAPI(+$P($G(^MAG(2005,IEN,100)),U,3)) D  Q
+ I PLACE'=$$PLACE^MAGBAPI($P($G(^MAG(2005,IEN,100)),U,3)) D  Q
  . S RESULT="-3^^15" Q  ;Foreign Place
  S ZNODE=^MAG(2005,IEN,0)
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGQBTM.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGQBTM.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGQBTM.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGQBTM ;WOIFO/RMP - REMOTE Task SERVER Program [ 03/25/2001 11:20 ]
- ;;3.0;IMAGING;**1,7,8,20,81**;May 17, 2007
- ;;  Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**1,7,8,20**;Apr 12, 2006
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -9,4 +8,5 @@
  ;; | Development Office of the Department of Veterans Affairs,     |
  ;; | telephone (301) 734-0100.                                     |
+ ;; |                                                               |
  ;; | The Food and Drug Administration classifies this software as  |
  ;; | a medical device.  As such, it may not be changed in any way. |
@@ -18,8 +18,8 @@
  ;
 ENTRY(RESULT,WSTAT,PROCESS) ; RPC[MAGQ ABP]
- N X,SYSIEN,SYSNAME,NODE,INDX,CNT,PROC,%,QPTR,QCNT,VERS,EXEDATE,WSOS,PLACE,VOK
+ N X,SYSIEN,SYSNAME,NODE,INDX,CNT,PROC,%,QPTR,QCNT,VERS,EXEDATE,WSOS,PLACE
  D NOW^%DTC
  S X="ERR^MAGQBTM",@^%ZOSF("TRAP")
- S (SYSIEN,CNT)=0,SYSNAME="",PLACE=$$PLACE^MAGBAPI(+$G(DUZ(2))),VOK=""
+ S (SYSIEN,CNT)=0,SYSNAME="",PLACE=$$PLACE^MAGBAPI(+$G(DUZ(2)))
  S $P(RESULT(0),U,6)=$D(^XUSEC("MAG SYSTEM",DUZ))
  Q:'$P(RESULT(0),U,6)
@@ -38,6 +38,5 @@
  S $P(^MAG(2006.8,SYSIEN,1),U,4)=WSOS
  S VERS=$P(VERS,".",1,2)_"P"_$P(VERS,".",3)
- D VOKR^MAGQBUT4(.VOK,VERS)
- Q:'$P(VOK,U)
+ Q:'$$VOK^MAGQBUT4(VERS)
  S ^TMP("MAGQN",$J,0)=SYSIEN_"^"_WSTAT
  S NODE=^MAG(2006.8,SYSIEN,0)
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGQBUT1.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGQBUT1.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGQBUT1.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGQBUT1 ;WOIFO/RP; Utilities for Background [ 03/25/2001 11:20 ]
- ;;3.0;IMAGING;**7,8,20,81**;May 17, 2007
- ;;  Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**7,8,20**;Apr 12, 2006
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -9,4 +8,5 @@
  ;; | Development Office of the Department of Veterans Affairs,     |
  ;; | telephone (301) 734-0100.                                     |
+ ;; |                                                               |
  ;; | The Food and Drug Administration classifies this software as  |
  ;; | a medical device.  As such, it may not be changed in any way. |
@@ -180,5 +180,5 @@
  F INC=FROM:1:TO D
  . I ('$D(^MAG(2005,INC,0))&('$D(^MAG(2005.1,INC,0)))) Q
- . I ($$PLACE^MAGBAPI(+$P($G(^MAG(2005,INC,100)),U,3))'=PLACE)&($$PLACE^MAGBAPI(+$P($G(^MAG(2005.1,INC,100)),U,3)'=PLACE)) Q
+ . I ($P($G(^MAG(2005,INC,100)),U,3)'=INST)&($P($G(^MAG(2005.1,INC,100)),U,3)'=INST) Q
  . I ($P($G(^MAG(2005,INC,0)),"^",2)="")&($P($G(^MAG(2005.1,INC,0)),"^",2)="") Q  ;No full filename attribute
  . I (+$P($G(^MAG(2005,INC,1,0)),"^",4)>0)!(+$P($G(^MAG(2005.1,INC,1,0)),"^",4)>0) Q  ;GROUP PARENT
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGQBUT2.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGQBUT2.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGQBUT2.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGQBUT2 ;WOIFO/SRR/RMP -IMAGE SITE PARAMETERS COMPANION [ 11/08/2001 17:18 ]
- ;;3.0;IMAGING;**7,8,20,81**;May 17, 2007
- ;;  Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**7,8,20**;Apr 12, 2006
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -9,4 +8,5 @@
  ;; | Development Office of the Department of Veterans Affairs,     |
  ;; | telephone (301) 734-0100.                                     |
+ ;; |                                                               |
  ;; | The Food and Drug Administration classifies this software as  |
  ;; | a medical device.  As such, it may not be changed in any way. |
@@ -16,6 +16,37 @@
  ;; +---------------------------------------------------------------+
  ;;
+VSTAV() ;
+ N VER,IEN,ARRAY,VALUE,LATEST
+ S VER=$$VERSION^XPDUTL("IMAGING")
+ S:$T(LAST^XPDUTL)]"" VER=VER_"^"_$$LAST^XPDUTL("IMAGING",VER)
+ Q VER
+IWSV(WSD,WSC,WSV,PLACE) ;IMAGE WORKSTATION VERSIONS
+ N IEN,NODE,RD,OS
+ S RD=$$FMADD^XLFDT($$NOW^XLFDT,-180,"","","")
+ S IEN=0
+ F  S IEN=$O(^MAG(2006.81,"C",PLACE,IEN)) Q:IEN'?1N.N  D
+ . S NODE=^MAG(2006.81,IEN,0)
+ . Q:($P(NODE,U,3)<RD)
+ . S OS=$P($G(^MAG(2006.81,IEN,1)),U,2)
+ . I $P(NODE,"^",9)'="" D
+ . . S INDEX=$P(NODE,"^",9),INDEX=$S(OS="":INDEX,1:INDEX_U_OS)
+ . . S WSD(INDEX)=$G(WSD(INDEX))+1
+ . I $P(NODE,"^",13)'="" D
+ . . S INDEX=$P(NODE,"^",13),INDEX=$S(OS="":INDEX,1:INDEX_U_OS)
+ . . S WSC(INDEX)=$G(WSC(INDEX))+1
+ . I $P(NODE,"^",15)'="" D
+ . . S INDEX=$P(NODE,"^",15),INDEX=$S(OS="":INDEX,1:INDEX_U_OS)
+ . . S WSV(INDEX)=$G(WSV(INDEX))+1
+ Q
+DICOMV(DCMG) ;Version of DICOM
+ N X,ARRAY,IEN,NAME
+ S X=""
+ F  S X=$O(^MAG(2006.83,"B",X)) Q:X=""  D
+ . S IEN=$O(^MAG(2006.83,"B",X,"")) Q:IEN'?1N.N
+ . S DCMG($P(^MAG(2006.83,IEN,0),U,3))=$G(DCMG($P(^MAG(2006.83,IEN,0),U,3)))+1
+ Q $S($D(DCMG):1,1:0)
+VISTARV() ;
+ Q $$VERSION^XPDUTL("MAGJ RADIOLOGY")
 MAGSYS(LIST) ;
- ; RPC[MAGQ SYSTEM]
  N VAIEN,NODE,MGIEN,UNAME,TDATE
  S MGIEN=$$FIND1^DIC(3.8,"","MX","MAG SERVER","","","ERR")
@@ -31,5 +62,5 @@
  . S LIST(VAIEN)=VAIEN_"^"_UNAME
  Q
-IMPAR(RESULT,QIEN) ; Import Array
+IMPAR(RESULT,QIEN) ;
  N INDX,CNT
  S (INDX,CNT)=0
@@ -40,4 +71,11 @@
  E  S RESULT(0)="1"
  Q
+SNS(PLACE) ;
+ N RESULT,INDEX
+ S INDEX=0
+ S RESULT=$P(^MAG(2006.1,PLACE,0),U,2)
+ F  S INDEX=$O(^MAG(2006.1,PLACE,4,INDEX)) Q:INDEX'?1N.N  D
+ . S RESULT=RESULT_U_$P($G(^MAG(2006.1,PLACE,4,INDEX,0)),U)
+ Q RESULT
 CHKIMG(IEN) ;
  ; Given an Image IEN, return:
@@ -84,10 +122,9 @@
  S IDFN=$P(X0,"^",7),$P(R,"^",4)=IDFN
  S PT(3.9)="^XMB(3.9,PD0,|Mail message||2|^XMB(3.9,PD0,2005,|MAIL"
- ; The following 5 Lab subsections must be in-synch with FILE+42^MAGGTLB1
  S PT(63)="^LR(PD0,GF,PD1,|Autopsy (microscopic)|AY|1|^LR(PD0,GF,PD1,2005,|AUM"
  S PT(63.02)="^LR(PD0,GF,PD1,|Electron microscopy|EM|1|^LR(PD0,GF,PD1,2005,|EM"
  S PT(63.08)="^LR(PD0,GF,PD1,|Surgical pathology|SP|1|^LR(PD0,GF,PD1,2005,|SP"
  S PT(63.09)="^LR(PD0,GF,PD1,|Cytology|CY|1|^LR(PD0,GF,PD1,2005,|CY|"
- S PT(63.2)="^LR(PD0,GF,PD1,|Autopsy (gross)|AY|1|^LR(PD0,GF,PD1,2005,|AUG"
+ S PT(63.2)="^LR(PD0,GF,PD1,|Autopsy (gross)|AU|1|^LR(PD0,GF,PD1,2005,|AUG"
  S PT(70)="^RADPT(PDFN,|Radiology Patient||1|"
  S PT(74)="^RARPT(PD0,|Radiology||2|^RARPT(PD0,2005,|RAD"
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGQBUT4.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGQBUT4.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGQBUT4.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGQBUT4 ;WOIFO/RMP - BP Utilities  ;19 Nov 2001 1:23 PM
- ;;3.0;IMAGING;**7,8,48,20,81**;May 17, 2007
- ;;  Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**7,8,48,20**;Apr 12, 2006
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -9,4 +8,5 @@
  ;; | Development Office of the Department of Veterans Affairs,     |
  ;; | telephone (301) 734-0100.                                     |
+ ;; |                                                               |
  ;; | The Food and Drug Administration classifies this software as  |
  ;; | a medical device.  As such, it may not be changed in any way. |
@@ -83,13 +83,13 @@
  . Q
  Q
- ;
-VOKR(RESULT,VER) ; RPC for VOK [MAGQ VOK]
- N CVERS,PNUM,SLINE
- S X="ERR^MAGQBTM",@^%ZOSF("TRAP")
- S SLINE=$T(+2)
+VOK(VER) ; Check for the appropriate BP Queue processor version
+ ; This routine MAGQBUT4 will need to be released with each BP Update
+ ; The variable CVERS will contain the current BP server version
+ ;       ;;3.0;IMAGING;**7,13,8**;Jul 26, 2004
+ N VN,I,CVERS,PNUM,SLINE,ALTVER
+ S SLINE=$T(+2),ALTVER=","_$$TRIM($P(SLINE,"**",2))_","
  S PNUM=$$TRIM($P(SLINE,"**",2)),PNUM=$$TRIM($P(PNUM,",",$L(PNUM,",")))
  S CVERS=$$TRIM($P(SLINE,";",3))_"P"_PNUM
- S RESULT=$S(CVERS=VER:1,1:0)_U_CVERS
- Q
+ Q $S(CVERS=VER:1,$P(VER,"P",2)["13":1,ALTVER[(","_$P(VER,"P",2)_","):1,1:0)
  ;
 TRIM(X) ; remove both leading and trailing blanks
